﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import com.Tutorial.LevelFactory;
	import com.Tutorial.MenuState;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class IntroState extends FlxState
	{
		private var _introTimer:Number;
		private var _pressed:Boolean;
		private var _gameOver:Boolean;
		private var _lf:LevelFactory;
		
		public function IntroState():void
		{
			FlxG.setCursor(MenuState.ImgCursor);

			FlxG.stopMusic();
			FlxG.flash(0xff000000, 1);
			_lf = new LevelFactory;
			_introTimer = 2;
			_pressed = false;
			
			if (FlxG.level == PlayState.levelMAX)
			{
				_gameOver = true;
			}
			else
			{
				_gameOver = false;
			}
			
			if (!_gameOver)
			{
				this.add(new FlxText(0, (FlxG.width / 2) - 80, FlxG.width, 80, "Season " + (FlxG.level + 1), 0xffffffff, null, 16, "center")) as FlxText;
				this.add(new FlxText(0, (FlxG.width / 2) - 40, FlxG.width, 80, _lf.GetTitle(FlxG.level), 0xffffffff, null, 8, "center")) as FlxText;
			}
			else
			{
				this.add(new FlxText(0, (FlxG.width / 2) - 80, FlxG.width, 80, "The End", 0xffffffff, null, 32, "center")) as FlxText;
				var _btn:FlxButton = new FlxButton(
					40,
					140,
					new FlxSprite(null, 0, 0, false, false, FlxG.width - 80, 15, 0xff423954), 
					onClick, 
					new FlxSprite(null, 0, 0, false, false, FlxG.width - 80, 15, 0xffbaaad2), 
					new FlxText(0,1, FlxG.width-80, 15, "Return to Title Screen", 0xffffffff,null,8,"center"), 
					new FlxText(0,1, FlxG.width-80, 15, "Return to Title Screen", 0xfffff161,null,8,"center")
					);	
					
				this.add(_btn);
			}
			
												  
		}
		
		
        override public function update():void
		{
			_introTimer -= FlxG.elapsed;
			
			if (FlxG.justPressed(FlxG.A || FlxG.B))
			{
				_pressed = true;
			}
			
			if ((_introTimer <= 0 || (_pressed && _introTimer<1.5))&&!_gameOver)
			{
				FlxG.fade(0xff000000, 2, introDone, true);
				_introTimer = 100000;
			}

			super.update();
		}
		
		private function introDone():void
		{
			if (!_gameOver)
				FlxG.switchState(PlayState);
			else
				FlxG.switchState(MenuState);			
		}
		
		private function onClick():void
		{
			FlxG.play(MenuState.SndOpen); 			
			FlxG.switchState(MenuState);						
		}
		
	}

}