﻿package com.Tutorial 
{
	import com.adamatomic.flixel.FlxArray;
	import com.Tutorial.Person;
	import com.Tutorial.Transformation;
	import com.Tutorial.TransformationFactory;
	import org.flashdevelop.utils.FlashConnect;	
	import com.Tutorial.NameFactory;

	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */	
	public class LevelData
	{
		public var title:String;
		public var actors:FlxArray;
		public var transformations:FlxArray;
		private var transformationfactory:TransformationFactory;

		public function LevelData(str:String) 
		{
			actors = new FlxArray();
			transformations = new FlxArray();
			transformationfactory = new TransformationFactory();
			var nameFactory:NameFactory;	
			nameFactory = new NameFactory();		

			var i:int;
			var j:int;
			var k:int;
			var m:int;
			var n:int;
			var stack:Array;
			var line:String;
			var operation:String;
			
			var divided:Array = str.split(",");
									
			if (divided.length < 4)
				FlashConnect.trace("LEVELSTRINGTOOSMALL".concat(str));
			
			for (n = 0; n < divided.length; n++)
			{
				divided[n]=Transformation.trim(divided[n]);
			}
			
			title = divided[0];
			
			for ( i = 0 ; i < int(divided[1]); i++)
			{
				actors.push(new Person());
				actors[i].name = nameFactory.GetName();
			}
			
			line = divided[2];			
			var ar:Array = line.split(" ");
			for (i = 0; i < ar.length; i++)
			{
				ar[i] = Transformation.trim(ar[i]);
			}
			
			var toAdd:int;
			
			for (i = 0; i < ar.length; i++)
			{		
				operation = ar[i].charAt(0).toLowerCase();
				toAdd = -1;
				stack = new Array();

				for (j = 1; j < ar[i].length; j++)
				{
					switch (ar[i].charAt(j))
					{
						case "a":
							toAdd = 0;
							break;
						case "b":
							toAdd = 1;
							break;
						case "c":
							toAdd = 2;
							break;
						case "d":
							toAdd = 3;
							break;
						case "e":
							toAdd = 4;
							break;
					}
					
					
					switch (operation)
					{		
						case "p":
							actors[toAdd].power = true;
						break;
						case "o":
							actors[toAdd].object = true;
						break;
						case "c":
							actors[toAdd].criminal = true;
						break;
						case "v":
							actors[toAdd].victim = true;
						break;
						case "k":			
							if (stack.indexOf(toAdd) == -1)
							{
								for ( j = 0; j < stack.length; j++)
								{
									m = int(stack[j]);
									n = toAdd;
									if (m != n)
									{
										actors[m].kinsmen.push(actors[n].name);
										actors[n].kinsmen.push(actors[m].name);
									}
								}
								stack.push(toAdd);
							}
						break;
						case "s":	
							if (stack.indexOf(toAdd) == -1)
							{
								for ( j = 0; j < stack.length; j++)
								{
									m = int(stack[j]);
									n = toAdd;
									if (m != n)
									{
										actors[m].spouse = actors[n].name;
										actors[n].spouse = actors[m].name;
									}
								}
								stack.push(toAdd);
							}
						break;
						case "l":	
							if (stack.indexOf(toAdd) == -1)
							{
								for ( j = 0; j < stack.length; j++)
								{
									m = int(stack[j]);
									n = toAdd;
									if (m != n)
									{
										actors[m].lovers.push(actors[n].name);
										actors[n].lovers.push(actors[m].name);
									}
								}
								stack.push(toAdd);
							}
						break;
						case "h":
							if (stack.indexOf(toAdd) == -1)
							{
								for ( j = 0; j < stack.length; j++)
								{
									m = int(stack[j]);
									n = toAdd;
									if (m != n)
									{
										actors[m].hates.push(actors[n].name);
										actors[n].hates.push(actors[m].name);
									}
								}
								stack.push(toAdd);
							}
						break;
					}	
				}
			}
			
			divided.splice(0, 3);
			divided.sort();
			// add transformations
			for (i = 0; i < divided.length; i++)
			{
				transformations.push(transformationfactory.GetTransformation(divided[i]));
			}
		}
			
		public static function shuffle(arr:FlxArray):FlxArray
		{
			var res:FlxArray = arr;
			
			for(var i:int = 0; i < res.length; i++){
				var a:int = res[i];
				var b:int = Math.floor(Math.random() * res.length);
				res[i] = res[b];
				res[b] = a;
			}
			return res;
		}
	
	}

}