﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	import com.adamatomic.flixel.data.FlxAnim;
	import com.Tutorial.Transformation;
	import com.Tutorial.TransformationFactory;
	import com.Tutorial.LevelData;
	import com.Tutorial.LevelFactory;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import org.flashdevelop.utils.FlashConnect;
	import flash.display.Bitmap;
	import com.Tutorial.PlayerSprite;
	
    public class PlayState extends FlxState
    {
		[Embed(source="../../data/bling.mp3")] private var SndBling:Class;
		[Embed(source="../../data/cat.mp3")] private var SndCat:Class;
		[Embed(source = "../../data/open.mp3")] private var SndOpen:Class;
		[Embed(source = "../../data/bg.png")] private var BgBMP:Class;
		[Embed(source="../../data/cursor.png")] private var ImgCursor:Class;
		[Embed(source="../../data/kinsmen.png")] private var ImgKin:Class;
		[Embed(source="../../data/love.png")] private var ImgLove:Class;
		[Embed(source="../../data/hate.png")] private var ImgHate:Class;
		[Embed(source="../../data/married.png")] private var ImgMarried:Class;
		[Embed(source="../../data/kinsmen2.png")] private var ImgKin2:Class;
		[Embed(source="../../data/love2.png")] private var ImgLove2:Class;
		[Embed(source="../../data/hate2.png")] private var ImgHate2:Class;
		[Embed(source = "../../data/married2.png")] private var ImgMarried2:Class;
		[Embed(source="../../data/gaol.png")] private var ImgGaol:Class;
		[Embed(source="../../data/selected.png")] private var ImgSelected:Class;
		[Embed(source = "../../data/buttonhighlight.png")] private var ImgHighlighted:Class;
		[Embed(source = "../../data/game.mp3")] private var SndGame:Class;

					
		private const _fillOrder:Array = [1, 3, 2, 0, 4];
		private var _endTimer:Number;
		private var _bCanReset:Boolean;
		
		private var _levelData:LevelData;
		
		private var _levelLabel:FlxText;				
				
        public static var lyrFG:FlxLayer;
        public static var lyrStage:FlxLayer;
        public static var lyrList:FlxLayer;
        public static var lyrTrans:FlxLayer;
        public static var lyrBG:FlxLayer;
        
		public static var levelMAX:Number = 10;
				
		public var transformationFactory:TransformationFactory;			
		public var levelFactory:LevelFactory;		
		
		private var _slots:Array;
		
		private var _selectedTransformation:int;
		private var _selectedCharacter:int;
		private var _listOffset:int;
		private var _insertTarget:int;

		private var _upbtn:FlxButton;
		private var _downbtn:FlxButton;
		private var _list:FlxArray;
		private var _bg:FlxSprite;
		private var _charDesc:FlxText;
		private var _beforeText:FlxText;
		private var _afterText:FlxText;
		private var _transName:FlxText;
		private var _levelComplete:FlxText;
		private var _performButton:FlxButton;
		private var _restartButton:FlxButton;
		private var _tb1:FlxButton;
		private var _tb2:FlxButton;
		private var _tb3:FlxButton;
		private var _im1:PlayerSprite;
		private var _im2:PlayerSprite;
		private var _im3:PlayerSprite;
		private var _tl1:FlxText;
		private var _tl2:FlxText;
		private var _tl3:FlxText;
		
		private var _charBTNs:FlxArray;
		private var _charIMGs:FlxArray;				
		private var _gaolIMGs:FlxArray;		
		private var _hateIMGs:FlxArray;		
		private var _kinIMGs:FlxArray;		
		private var _loveIMGs:FlxArray;		
		private var _spouseIMGs:FlxArray;				
		private var _hate2IMGs:FlxArray;		
		private var _kin2IMGs:FlxArray;		
		private var _love2IMGs:FlxArray;		
		private var _spouse2IMGs:FlxArray;		

		private var _target:FlxSprite;
		
		private var _imageIndices:FlxArray;
		
		
		private function updateUI():void
		{
			var i:int;
			
			//_levelData.transformations
			_upbtn.visible = true;
			_upbtn.active = true;
			_downbtn.visible = true;
			_downbtn.active = true;
				
			if (_levelData.transformations.length == 0)
			{
				_levelComplete.visible = true;
				_levelComplete.update();
				_selectedTransformation = -1;
				FlxG.fade(0xff000000, 2, levelOver, true);
			}
			
			if (_selectedTransformation >= _levelData.transformations.length)
			{
				_selectedTransformation = _levelData.transformations.length - 1;
			}
			
			if (_listOffset > 0 && _levelData.transformations.length - _listOffset < 6)
			{
				_listOffset = Math.max(0, _levelData.transformations.length - 7);
			}
			
			if (_levelData.transformations.length <= 6 )
			{
				_upbtn.visible = false;
				_downbtn.visible = false;
				_upbtn.active = false;
				_downbtn.active = false;
			}
			
			if (_listOffset == 0)
			{
				_upbtn.visible = false;
				_upbtn.active = false;
			}
			

			if (_levelData.transformations.length - _listOffset<=6)
			{
				_downbtn.visible = false;
				_downbtn.active = false;
			}
			
			_upbtn.update();
			_downbtn.update();
			
			for (i = 0; i < 6; i++)
			{
				if (_selectedTransformation == _listOffset + i)
				{
					_list[i].switchOn();
				}
				else
				{
					_list[i].switchOff();
				}
			}
			
			for (i = 0; i < 6; i++)
			{
				if (_listOffset + i < _levelData.transformations.length)
				{
					var t:Transformation = _levelData.transformations[_listOffset+i];
					_list[i].visible = true; 
					_list[i]._offT = new FlxText(0, 0, 75, 15, t.AbbreviatedName, 0xffffffff , null, 8, "center"), 
					_list[i]._onT  = new  FlxText(0, 0, 75, 15, t.AbbreviatedName, 0xfffff161 , null, 8, "center")
				}
				else 
				{
					_list[i].visible = false;
				}
				_list[i].update();
			}

			
			for (i = 0; i < 5; i++)
			{
				_gaolIMGs[i].visible = false;
				_hateIMGs[i].visible = false;
				_spouseIMGs[i].visible = false;
				_kinIMGs[i].visible = false;
				_loveIMGs[i].visible = false;
				_hate2IMGs[i].visible = false;
				_spouse2IMGs[i].visible = false;
				_kin2IMGs[i].visible = false;
				_love2IMGs[i].visible = false;
			}
			
			var p:Person;
			var q:Person;
			if (_selectedCharacter>=0)
				p = _levelData.actors[_selectedCharacter];
			else
				p = null;
			
			if (_selectedCharacter>=0)
			{
				_charDesc.setText(p.GetDescription());
				_charDesc.visible = true;
				_charDesc.update();
				

				_target.x = 88 + 30 * _fillOrder[_selectedCharacter] - 2;
				_target.visible = true;
				_target.update();
			}
			else
			{
				_charDesc.visible = false;
				_charDesc.update();
				_target.visible = false;
				_target.update();
			}
				
			for (i = 0; i < _levelData.actors.length; i++)
			{
				if (i == _selectedCharacter)
				{						
					if (p.hates.length > 0 )
						_hate2IMGs[i].visible = true;
					if (p.spouse != "")
						_spouse2IMGs[i].visible = true;
					if (p.kinsmen.length > 0 )
						_kin2IMGs[i].visible = true;
					if (p.lovers.length > 0 )
						_love2IMGs[i].visible = true;
					if (p.criminal)
						_gaolIMGs[i].visible = true;
				}
				else
				{						
					q = _levelData.actors[i];
					
					if (p&&q.hates.indexOf(p.name) >=0 )
						_hate2IMGs[i].visible = true;
					else if (q.hates.length > 0)
						_hateIMGs[i].visible = true;
					if (p&&q.spouse == p.name)
						_spouse2IMGs[i].visible = true;
					else if (q.spouse!="")
						_spouseIMGs[i].visible = true;
					if (p&&q.kinsmen.indexOf(p.name) >=0 )
						_kin2IMGs[i].visible = true;
					else if (q.kinsmen.length > 0)
						_kinIMGs[i].visible = true;
					if (p&&q.lovers.indexOf(p.name) >=0 )
						_love2IMGs[i].visible = true;
					else if (q.lovers.length > 0)
						_loveIMGs[i].visible = true;
					if (q.criminal)
						_gaolIMGs[i].visible = true;
				}
			}
			
			
			for (i = _levelData.actors.length; i < 5; i++)
			{
				_gaolIMGs[i].update();
				_hateIMGs[i].update();
				_spouseIMGs[i].update();
				_kinIMGs[i].update();
				_loveIMGs[i].update();
				_hate2IMGs[i].update();
				_spouse2IMGs[i].update();
				_kin2IMGs[i].update();
				_love2IMGs[i].update();
			}
			
			if (_selectedTransformation >= 0)
			{			
				t = _levelData.transformations[_selectedTransformation];

				_transName.visible = true;
				_transName.setText(t.LongName);
				
				_beforeText.visible = true;
				_beforeText.setText(t.RequirementsString());
				
				_afterText.visible = true;
				_afterText.setText(t.ChangesString());
				
				var allfull:Boolean;
				allfull = true;
				for (i = 0; i < t.Arity; i++)
				{
					if (_slots[i] == -1)
					{
						allfull = false;
						break;
					}
				}
				
				if (!allfull)
				{
					_performButton.visible = false;
					_performButton.active = false;
				}
				else
				{
					_performButton.visible = true;
					_performButton.active = true;	
				}
				
				if (_slots[0] != -1)
				{
					p = _levelData.actors[_slots[0]];
					_im1.SetState(p.object, p.power, p.victim, _imageIndices[_slots[0]]);
					_im1.update();
				}
				_im1.visible = _slots[0] != -1;
				
				if (_slots[1] != -1)
				{
					p = _levelData.actors[_slots[1]];
					_im2.SetState(p.object, p.power, p.victim, _imageIndices[_slots[1]]);
					_im2.update();
				}
				_im2.visible = _slots[1] != -1;
				
				if (_slots[2] != -1)
				{
					p = _levelData.actors[_slots[2]];
					_im3.SetState(p.object, p.power, p.victim, _imageIndices[_slots[2]]);
					_im3.update();
				}
				_im3.visible = _slots[2] != -1;
				
				//only display/enable buttons if thing is selected
				_tl1.visible = true;					
				_tb1.visible = false;				
				_tb1.active = false;
				if (_selectedCharacter >= 0)
				{
					var ar:Array;
					ar = new Array();
					for (i = 0; i < t.Arity; i++)
					{
						if (_slots[i]!=-1 && (_selectedCharacter!=_slots[i]))
							ar[i]=_levelData.actors[_slots[i]];
						else
							ar[i] = null;
					}
					
					ar[0] = _levelData.actors[_selectedCharacter];

					if (t.Passes(ar) && _slots[0]!=_selectedCharacter)
					{
						_tb1.visible = true;
						_tb1.active = true;		
					}
				}
				
				if (t.Arity > 1)
				{
					_tl2.visible = true;
					_tb2.visible = false;				
					_tb2.active = false;
					if (_selectedCharacter >= 0)
					{
						ar = new Array();
						for (i = 0; i < t.Arity; i++)
						{
							if (_slots[i]!=-1 && (_selectedCharacter!=_slots[i]))
								ar[i]=_levelData.actors[_slots[i]];
							else
								ar[i] = null;
						}
						
						ar[1] = _levelData.actors[_selectedCharacter];

						if (t.Passes(ar) && _slots[1]!=_selectedCharacter)
						{
							_tb2.visible = true;
							_tb2.active = true;		
						}
					}
				}
				else
				{
					_tl2.visible = false;				
					_tb2.visible = false;	
					_tb2.active = false;
					_im2.visible = false;					
				}
				
				if (t.Arity > 2)
				{
					_tl3.visible = true;
					_tb3.visible = false;				
					_tb3.active = false;
					if (_selectedCharacter >= 0)
					{
						ar = new Array();
						for (i = 0; i < t.Arity; i++)
						{
							if (_slots[i]!=-1 && (_selectedCharacter!=_slots[i]))
								ar[i]=_levelData.actors[_slots[i]];
							else
								ar[i] = null;
						}
						
						ar[2] = _levelData.actors[_selectedCharacter];

						if (t.Passes(ar) && _slots[2]!=_selectedCharacter)
						{
							trace("passes 3");
							_tb3.visible = true;
							_tb3.active = true;		
						}
					}
				}
				else
				{
					_tl3.visible = false;				
					_tb3.visible = false;	
					_tb3.active = false;	
					_im3.visible = false;			
				}
			}
			else
			{
				_transName.visible = false;
				_beforeText.visible = false;
				_afterText.visible = false;
				_performButton.visible = false;
				_performButton.active = false;
				_tl1.visible = false;				
				_tl2.visible = false;				
				_tl3.visible = false;	
				_tb1.visible = false;				
				_tb1.active = false;	
				_im1.visible = false;				
				_tb2.visible = false;				
				_tb2.active = false;	
				_im2.visible = false;				
				_tb3.visible = false;	
				_tb3.active = false;	
				_im3.visible = false;
				
			}
			
			for (i = 0; i < _levelData.actors.length ; i++)
			{
				var a:Person; 
				a = _levelData.actors[i];
				var ps:PlayerSprite;
				ps = _charIMGs[i];
				ps.SetState(a.object, a.power, a.victim);
				ps.update();
				ps.play("1",true);
			}
				
			_transName.update();
			_beforeText.update();
			_afterText.update();
			_performButton.update();
			_tb1.update();
			_tb2.update();
			_tb3.update();	
			_tl1.update();
			_tl2.update();
			_tl3.update();
			_im1.update();
			_im2.update();
			_im3.update();
				
			lyrBG.update();
			lyrFG.update();
			lyrStage.update();
			lyrList.update();
			lyrTrans.update();

		}
		
        public function PlayState():void
        {
            super();
			FlxG.gstring = "";
			FlxG.setMusic(SndGame);
			FlxG.flash(0xff000000, 2);
			_slots = new Array();
			_slots = [ -1, -1, -1];
			_selectedCharacter = -1;
			_selectedTransformation = -1;
			
			transformationFactory = new TransformationFactory;
			levelFactory = new LevelFactory;
			
			_levelData = levelFactory.GetLevel(FlxG.level);
			_imageIndices = new FlxArray;
			
			var i:int;
			for (i = 0; i < 8; i++)
			{
				_imageIndices.push(i);
			}
			_imageIndices = shuffle(_imageIndices as Array) as FlxArray;
			
			FlxG.setCursor(ImgCursor);
			
			_listOffset = 0;
			
			_endTimer = -1;
			_bCanReset = false;
			
			
            lyrFG = new FlxLayer;
            lyrStage = new FlxLayer;
            lyrList = new FlxLayer;
            lyrBG = new FlxLayer;
            lyrTrans = new FlxLayer;

			_bg = new FlxSprite(BgBMP);	
			lyrBG.add(_bg);
			
			lyrFG.add(new FlxText(75, 0, FlxG.width-75, 12, levelFactory.GetTitle(FlxG.level), 0xffffffff, null, 10, "center"));
			_charDesc = new FlxText(4, 19, 71, 110, "Gwendoplast\n has object\n powerful\n loves:\n  regipoint",0xffffffff);
			lyrFG.add(_charDesc);
			
			_upbtn = new FlxButton(
					0,
					135,
					new FlxSprite(null, 0, 0, false, false, 75, 15, 0xffbaaad2), 
					listup, 
					new FlxSprite(null, 0, 0, false, false, 75, 15, 0xffbaaad2), 
					new FlxText(0,0,75, 15, "up", 0xffffffff,null,8,"center"), 
					new FlxText(0,0, 75, 15, "up", 0xfffff161,null,8,"center")
					);
			lyrList.add(_upbtn);
			_downbtn = new FlxButton(
					0,
					240,
					new FlxSprite(null, 0, 0, false, false, 75, 15, 0xffbaaad2), 
					listdown, 
					new FlxSprite(null, 0, 0, false, false, 75, 15, 0xffbaaad2), 
					new FlxText(0,0,75, 15, "down", 0xffffffff,null,8,"center"), 
					new FlxText(0,0, 75, 15, "down", 0xfffff161,null,8,"center")
					);
			lyrList.add(_downbtn);
			
			_list = new FlxArray;
			
			for (i = 0; i < 6; i++)
			{
				var cola:uint = i%2==0 ?1 : 2;
				var colb:uint;
				
				var f:Function;
				
				switch (i)
				{
					case 0:
					f = list0;
					break;
					case 1:
					f = list1;
					break;
					case 2:
					f = list2;
					break;
					case 3:
					f = list3;
					break;
					case 4:
					f = list4;
					break;
					case 5:
					f = list5;
					break;
				}
				
				_list.add(new FlxButton(0, 150 + 15 * i,
					new FlxSprite(null, 0, 0, false, false, 75, 15, i%2==0 ? 0xff62546d : 0xff423954 ), 
					f, 
					new FlxSprite(null, 0, 0, false, false, 75, 15, i%2==0 ? 0xff62546d : 0xff423954 ), 
					new FlxText(0, 0, 75, 15, "waffle" + i.toString(), 0xffffffff ,null , 8, "center"), 
					new FlxText(0, 0, 75, 15, "waffle" + i.toString() , 0xfffff161 , null, 8, "center")));
					
				lyrList.add(_list[_list.length - 1]);
			}
					
			_levelComplete = new FlxText(75, 60, 165, 16, "The End", 0xff000000, null, 16, "center");
			_levelComplete.visible = false;
			lyrFG.add(_levelComplete);

			//transformation panel
			{
				_beforeText = new FlxText(80, 189, 80, 100, "Before:\n A dead\n B has object", 0xffffffff);
				lyrTrans.add(_beforeText);
				_afterText = new FlxText(162, 189, 80, 100, "After:\n A dead\n B dead",0xffffffff);
				lyrTrans.add(_afterText);
				_transName = new FlxText(80, 136, FlxG.width-80, 60, "A Large Phallic Device",0xffffffff);
				lyrTrans.add(_transName);
				_performButton = new FlxButton(180, 240,
					new FlxSprite(null, 0, 0, false, false, 60, 15, i%2==0 ? 0xff605060 : 0xff423954 ), 
					tryPerform, 
					new FlxSprite(null, 0, 0, false, false, 60, 15, i%2==0 ? 0xff62546d : 0xff423954 ), 
					new FlxText(0, 0, 60, 15, "Perform", 0xff000000 , null, 8, "center"), 
					new FlxText(0, 0, 60, 15, "Perform", 0xff000000 , null, 8, "center"));
				lyrTrans.add(_performButton);
					
				_restartButton = new FlxButton(0, 0,
					new FlxSprite(null, 0, 0, false, false, 75, 15, i%2==0 ? 0xff605060 : 0xff423954 ), 
					clickRestart, 
					new FlxSprite(null, 0, 0, false, false, 75, 15, i%2==0 ? 0xff62546d : 0xff423954 ), 
					new FlxText(0, 0, 75, 15, "Restart", 0xff000000 , null, 8, "center"), 
					new FlxText(0, 0, 75, 15, "Restart", 0xff000000 , null, 8, "center"));			
				lyrTrans.add(_restartButton);

				
				_im1 = new PlayerSprite(120, 167, 0);
				lyrTrans.add(_im1);
				_tb1 = new FlxButton(120-2, 167-2,
					new FlxSprite(ImgHighlighted), 
					insert0, 
					new FlxSprite(null, 0, 0, false, false, 19, 19, 0x66ffffff ));
				lyrTrans.add(_tb1);
				_tl1 = new FlxText(120, 152, 15, 10, "A", 0xffffffff,null,8,"center");
				lyrTrans.add(_tl1);
				
				_im2 = new PlayerSprite(150, 167, 0);
				lyrTrans.add(_im2);
				_tb2 = new FlxButton(150-2, 167-2,
					new FlxSprite(ImgHighlighted), 
					insert1, 
					new FlxSprite(null, 0, 0, false, false, 19, 19, 0x66ffffff ));
				lyrTrans.add(_tb2);
				_tl2 = new FlxText(150, 152, 15, 10, "B", 0xffffffff,null,8,"center");
				lyrTrans.add(_tl2);
				
				_im3 = new PlayerSprite(180, 167, 0);
				lyrTrans.add(_im3);
				_tb3 = new FlxButton(180-2, 167-2,
					new FlxSprite(ImgHighlighted), 
					insert2, 
					new FlxSprite(null, 0, 0, false, false, 19, 19, 0x66ffffff ));
				lyrTrans.add(_tb3);
				_tl3 = new FlxText(180, 152, 15, 10, "C", 0xffffffff,null,8,"center");
				lyrTrans.add(_tl3);
			}					
						
			_charBTNs = new FlxArray();
			_charIMGs = new FlxArray();
			
			_gaolIMGs = new FlxArray();
			_hateIMGs = new FlxArray();
			_loveIMGs = new FlxArray();
			_kinIMGs = new FlxArray();
			_spouseIMGs = new FlxArray();
			_hate2IMGs = new FlxArray();
			_love2IMGs = new FlxArray();
			_kin2IMGs = new FlxArray();
			_spouse2IMGs = new FlxArray();
			
			_target = new FlxSprite(ImgSelected, 88 + 30 * i - 2, 88 - 2);
			_target.visible = false;
			lyrFG.add(_target);

			for (i = 0; i < 5; i++)
			{
				_charIMGs.push(new PlayerSprite(88 + 30 * (_fillOrder[i]), 88, _imageIndices[i]));
				lyrStage.add(_charIMGs[_charIMGs.length - 1]);		
				_gaolIMGs.push(new FlxSprite(ImgGaol, 88 + 30 * (_fillOrder[i]) - 2, 100));
				lyrStage.add(_gaolIMGs[_gaolIMGs.length - 1]);				
				_hateIMGs.push(new FlxSprite(ImgHate, 88 + 30 * (_fillOrder[i]) + 2, 74));
				lyrStage.add(_hateIMGs[_hateIMGs.length - 1]);								
				_loveIMGs.push(new FlxSprite(ImgLove, 88 + 30 * (_fillOrder[i]) + 2, 58));
				lyrStage.add(_loveIMGs[_loveIMGs.length - 1]);								
				_kinIMGs.push(new FlxSprite(ImgKin, 88 + 30 * (_fillOrder[i]) + 2, 66));
				lyrStage.add(_kinIMGs[_kinIMGs.length - 1]);								
				_spouseIMGs.push(new FlxSprite(ImgMarried, 88 + 30 * (_fillOrder[i]) + 2, 49));
				lyrStage.add(_spouseIMGs[_spouseIMGs.length - 1]);	
				
				_hate2IMGs.push(new FlxSprite(ImgHate2, 88 + 30 * (_fillOrder[i]) + 2, 74));
				lyrStage.add(_hate2IMGs[_hate2IMGs.length - 1]);								
				_love2IMGs.push(new FlxSprite(ImgLove2, 88 + 30 * (_fillOrder[i]) + 2, 58));
				lyrStage.add(_love2IMGs[_love2IMGs.length - 1]);								
				_kin2IMGs.push(new FlxSprite(ImgKin2, 88 + 30 * (_fillOrder[i]) + 2, 66));
				lyrStage.add(_kin2IMGs[_kin2IMGs.length - 1]);								
				_spouse2IMGs.push(new FlxSprite(ImgMarried2, 88 + 30 * (_fillOrder[i]) + 2, 49));
				lyrStage.add(_spouse2IMGs[_spouse2IMGs.length - 1]);								
				
				switch (i)
				{
					case 0:
					f = char0;
					break;
					case 1:
					f = char1;
					break;
					case 2:
					f = char2;
					break;
					case 3:
					f = char3;
					break;
					case 4:
					f = char4;
					break;
				}
				
				
				_charBTNs.push(new FlxButton(88+30*(_fillOrder[i])-2, 88-2,
					new FlxSprite(null, 0, 0, false, false, 19, 19, i%2==0 ? 0x33000000 : 0x33000000 ), 
					f, 
					new FlxSprite(null, 0, 0, false, false, 19, 19, i%2==0 ? 0x44000000 : 0x44000000 )));
				lyrFG.add(_charBTNs[_charBTNs.length - 1]);
			}
			
			
			
			for (i = _levelData.actors.length; i < 5; i++)
			{
				_charIMGs[i].visible = false;
				_charBTNs[i].visible = false;
				_charBTNs[i].active = false;
			}
            this.add(lyrBG);
            this.add(lyrStage);
            this.add(lyrTrans);
            this.add(lyrList);
            this.add(lyrFG);
			
			updateUI();

        }
        
        override public function update():void
        {			
			if (_endTimer > 0)
			{						
				_endTimer -= FlxG.elapsed;	
				if (_endTimer <= 0)
				{
					FlxG.switchState(IntroState);
					FlxG.stopMusic();
				}
				
				return;
			}
			
            super.update();
			
		}		
		
		
		public static function shuffle(arr:Array):Array
		{
			var res:Array = arr;
			
			for(var i:int = 0; i < res.length; i++){
				var a:int = res[i];
				var b:int = Math.floor(Math.random() * res.length);
				res[i] = res[b];
				res[b] = a;
			}
			return res;
		}
		
		private function listup():void 
		{
			_listOffset--;
			updateUI();
		}
		private function listdown():void 
		{
			_listOffset++;
			updateUI();			
		}
		
		private function list0():void
		{
			_selectedTransformation = _listOffset + 0;
			_slots = [-1,-1,-1];			
			updateUI();
		}
		private function list1(): void
		{
			_selectedTransformation = _listOffset + 1;
			_slots = [-1,-1,-1];			
			updateUI();
		}
		private function list2():void
		{
			_selectedTransformation = _listOffset + 2;
			_slots = [-1,-1,-1];			
			updateUI();
		}
		private function list3():void
		{
			_selectedTransformation = _listOffset + 3;
			_slots = [-1,-1,-1];			
			updateUI();
		}
		private function list4():void
		{
			_selectedTransformation = _listOffset + 4;
			_slots = [-1,-1,-1];			
			updateUI();
		}
		private function list5():void
		{
			_selectedTransformation = _listOffset + 5;
			_slots = [-1,-1,-1];			
			updateUI();
		}
		
		private function char0():void 
		{
			_selectedCharacter = 0;
			updateUI();
		}
		private function char1():void 
		{
			_selectedCharacter = 1;
			updateUI();
		}
		private function char2():void 
		{
			_selectedCharacter = 2;
			updateUI();
		}
		private function char3():void 
		{
			_selectedCharacter = 3;
			updateUI();
		}
		private function char4():void 
		{
			_selectedCharacter = 4;
			updateUI();
		}
		private function clickRestart():void
		{
			FlxG.switchState(IntroState);
		}
		private function insert0():void
		{
			_insertTarget = 0;
			tryInsert();
		}
		private function insert1():void
		{
			_insertTarget = 1;
			tryInsert();
		}
		private function insert2():void
		{
			_insertTarget = 2;
			tryInsert();
		}
		private function tryInsert():void
		{
			if (_slots[_insertTarget] == _selectedCharacter)
			{
				_slots[_insertTarget] = -1;
			}
			else
			{
				for (var i:int = 0; i < _slots.length; i++)
				{
					if (_slots[i] == _selectedCharacter)
						_slots[i] = -1;
				}
				
				_slots[_insertTarget] = _selectedCharacter;
			}
			updateUI();
		}
		private function tryPerform():void
		{
			var t:Transformation = _levelData.transformations[_selectedTransformation];

			var ar:Array;
			ar = new Array();
			var i:int;
			for (i = 0; i < t.Arity; i++)
			{
				if (_slots[i]!=-1)
					ar.push(_levelData.actors[_slots[i]]);
				else
					ar.push(null);
			}
			t.Transform(ar);
			_levelData.transformations.splice(_selectedTransformation, 1);
			_slots = [-1,-1,-1];			
			FlxG.flash(0x33220033, 0.5);
			updateUI();
		}
		private function levelOver():void
		{
			FlxG.switchState(SummaryState);
		}
    }    
}