﻿package com.Tutorial 
{
	import com.Tutorial.Person;	
	import org.flashdevelop.utils.FlashConnect;
	import com.Tutorial.Lusion;
    import com.adamatomic.flixel.*;


	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class Transformation
	{
		public var ReferenceName:String;
		public var AbbreviatedName:String;
		public var LongName:String;
		public var Arity:int;
		public var Description:String;
		
		public var PreIncludes:Array;
		public var PreExcludes:Array;
		
		public var PostIncludes:Array;
		public var PostExcludes:Array;
		
		public function Transformation(s:String) 
		{			
			var divided:Array = s.split(",");
									
			if (divided.length != 7)
				FlashConnect.trace("TOOBIG".concat(s));
			
			for (var n:int = 0; n < divided.length; n++)
			{
				divided[n]=trim(divided[n]);
			}
			
			ReferenceName = divided[0];
			AbbreviatedName = divided[1];				
			LongName = divided[2];
			Arity = divided[3].length;
			Description = divided[6];			
			
			PreIncludes = new Array();
			PreExcludes = new Array();
			PostIncludes = new Array();
			PostExcludes = new Array();
			
			var i:int;
			var category:String;
			var remove:Boolean;
			var toAdd:int;
			var ir:String;
			var lusion:Lusion;	
			var inclusion:Boolean;

			var lusionsText:Array = divided[4].split(" ");
			for (n = 0; n < lusionsText.length; n++)
			{
				var curlusionText:String = trim(lusionsText[n]);
				if (curlusionText == "")
					continue;
			
				inclusion = curlusionText.charAt(0) == curlusionText.charAt(0).toUpperCase();
				lusion = new Lusion();
				lusion.key = trim(curlusionText.charAt(0)).toLowerCase();
				curlusionText = curlusionText.substr(1);
				
				for (i = 0; i < curlusionText.length; i++)
				{
					lusion.value += xyzTo123(curlusionText.charAt(i)).toString();
				}
				
				if (inclusion)
					PreIncludes.push(lusion);
				else
					PreExcludes.push(lusion);								
			}
			
			lusionsText = divided[5].split(" ");
			for (n = 0; n < lusionsText.length; n++)
			{
				curlusionText = trim(lusionsText[n]);
				if (curlusionText == "")
					continue;
			
				inclusion = curlusionText.charAt(0) == curlusionText.charAt(0).toUpperCase();
				lusion = new Lusion();
				lusion.key = trim(curlusionText.charAt(0)).toLowerCase();
				curlusionText = curlusionText.substr(1);
				
				for (i = 0; i < curlusionText.length; i++)
				{
					lusion.value += xyzTo123(curlusionText.charAt(i)).toString();
				}
				
				if (inclusion)
					PostIncludes.push(lusion);
				else
					PostExcludes.push(lusion);								
			}

		}
		
		public function Passes(input:Array):Boolean
		{		
			var i:int;								
			var j:int;
			var k:int;
		
			var p:Person;
			var q:Person;
			
			for (i = 0; i < PreIncludes.length; i++)
			{
				switch (PreIncludes[i].key.toLowerCase())
				{
					case "p":
						p = input[int(PreIncludes[i].value)];
						if (p && !p.power)
						{
							trace("1");
							return false;
						}
					break;
					case "o":
						p = input[int(PreIncludes[i].value)];
						if (p && !p.object)
						{
							trace("2");
							return false;
						}
					break;
					case "c":
						p = input[int(PreIncludes[i].value)];
						if (p && !p.criminal)
						{
							trace("3");
							return false;
						}
					break;
					case "v":
						p = input[int(PreIncludes[i].value)];
						if (p && !p.victim)
						{
							trace("4");
							return false;
						}
					break;
					case "k":
						for (j = 0; j < PreIncludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreIncludes[i].value.length; k++)
							{
								p = input[PreIncludes[i].value.charAt(j)];
								q = input[PreIncludes[i].value.charAt(k)];
								
								if (p && q && (p.kinsmen.indexOf(q.name)==-1 || q.kinsmen.indexOf(p.name)==-1))
								{									
									trace("5");
									return false;
								}
								else if (p && p.kinsmen.length == 0)
								{
									return false;
								}
								else if (q && q.kinsmen.length == 0)
								{
									return false;
								}
							}
						}
					break;
					case "s":
						for (j = 0; j < PreIncludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreIncludes[i].value.length; k++)
							{
								p = input[PreIncludes[i].value.charAt(j)];
								q = input[PreIncludes[i].value.charAt(k)];
								
								if (p && q && (p.spouse!=q.name || q.spouse!=p.name) )
								{					
									trace("6");
									return false;
								}
								else if (p && p.spouse == "")
								{
									return false;
								}
								else if (q && q.spouse == "")
								{
									return false;
								}
							}
						}
					break;
					case "l":
						for (j = 0; j < PreIncludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreIncludes[i].value.length; k++)
							{
								p = input[PreIncludes[i].value.charAt(j)];
								q = input[PreIncludes[i].value.charAt(k)];
								
								if (p && q && (p.lovers.indexOf(q.name)==-1 || q.lovers.indexOf(p.name)==-1))
								{					
									trace("7");
									return false;
								}
								else if (p && p.lovers.length == 0)
								{
									return false;
								}
								else if (q && q.lovers.length == 0)
								{
									return false;
								}
							}
						}
					break;
					case "h":
						for (j = 0; j < PreIncludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreIncludes[i].value.length; k++)
							{
								p = input[PreIncludes[i].value.charAt(j)];
								q = input[PreIncludes[i].value.charAt(k)];
								
								if (p && q && (p.hates.indexOf(q.name)==-1 || q.hates.indexOf(p.name)==-1))
								{					
									trace("8");
									return false;
								}
								else if (p && p.hates.length == 0)
								{
									return false;
								}
								else if (q && q.hates.length == 0)
								{
									return false;
								}
							}
						}
					break;
				}
			}

			for (i = 0; i < PreExcludes.length; i++)
			{
				switch (PreExcludes[i].key)
				{
					case "p":
						p = input[int(PreExcludes[i].value)];
						if (p && p.power)
							return false;
					break;
					case "o":
						p = input[int(PreExcludes[i].value)];
						if (p && p.object)
							return false;
					break;
					case "c":
						p = input[int(PreExcludes[i].value)];
						if (p && p.criminal)
							return false;
					break;
					case "v":
						p = input[int(PreExcludes[i].value)];
						if (p && p.victim)
							return false;
					break;
					case "k":
						for (j = 0; j < PreExcludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreExcludes[i].value.length; k++)
							{
								p = input[PreExcludes[i].value.charAt(j)];
								q = input[PreExcludes[i].value.charAt(k)];
								
								if (p && q && ( p.kinsmen.indexOf(q.name)!=-1 || q.kinsmen.indexOf(p.name)!=-1))
								{
									return false;
								}
							}
						}
					break;
					case "s":
						for (j = 0; j < PreExcludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreExcludes[i].value.length; k++)
							{
								p = input[int(PreExcludes[i].value.charAt(j))];
								q = input[int(PreExcludes[i].value.charAt(k))];
								
								if (p && q && (p.spouse!="" || q.spouse!="") )// A B not married = A not married + B not married
								{
									return false;
								}
							}
						}
					break;
					case "l":
						for (j = 0; j < PreExcludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreExcludes[i].value.length; k++)
							{
								p = input[int(PreExcludes[i].value.charAt(j))];
								q = input[int(PreExcludes[i].value.charAt(k))];
								
								if (p && q && (p.lovers.indexOf(q.name)!=-1 || q.lovers.indexOf(p.name)!=-1))
								{
									return false;
								}
							}
						}
					break;
					case "h":
						for (j = 0; j < PreExcludes[i].value.length; j++)
						{						
							for (k = j+1; k < PreExcludes[i].value.length; k++)
							{
								p = input[int(PreExcludes[i].value.charAt(j))];
								q = input[int(PreExcludes[i].value.charAt(k))];
								
								if (p && q && (p.hates.indexOf(q.name)!=-1 || q.hates.indexOf(p.name)!=-1))
								{
									return false;
								}
							}
						}
					break;
				}
			}

			return true;
		}
		
		public function Transform(input:Array):Array 
		{
			var lusion:Lusion;
			var p:Person;
			var q:Person;
						
			//apply modifications
			var i:int;
			var j:int;
			var k:int;
			var m:int;
			var n:int;
			var s1:int;
			var s2:int;
			for (i = 0; i < PostIncludes.length; i++)
			{
				lusion = PostIncludes[i];
				switch(lusion.key)
				{
					case "p":
						input[int(lusion.value)].power = true;
					break;
					case "o":
						input[int(lusion.value)].object = true;
					break;
					case "c":
						input[int(lusion.value)].criminal=true;
					break;
					case "v":
						input[int(lusion.value)].victim=true;
					break;
					case "k":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								if (input[m].kinsmen.indexOf(input[n].name) == -1)
									input[m].kinsmen.push(input[n].name);
								if (input[n].kinsmen.indexOf(input[m].name) == -1)
									input[n].kinsmen.push(input[m].name);
							}							
						}
					break;
					case "s":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								if (input[m].spouse!=input[n].name)
									input[m].spouse=input[n].name;
								if (input[n].spouse!=input[m].name)
									input[n].spouse=input[m].name;
							}							
						}
					break;
					case "l":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								if (input[m].lovers.indexOf(input[n].name) == -1)
									input[m].lovers.push(input[n].name);
								if (input[n].lovers.indexOf(input[m].name) == -1)
									input[n].lovers.push(input[m].name);
							}							
						}
					break;
					case "h":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								if (input[m].hates.indexOf(input[n].name) == -1)
									input[m].hates.push(input[n].name);
								if (input[n].hates.indexOf(input[m].name) == -1)
									input[n].hates.push(input[m].name);
							}							
						}
					break;
				}
			}
			
			for (i = 0; i < PostExcludes.length; i++)
			{
				lusion = PostExcludes[i];
				switch(lusion.key.toLowerCase() )
				{
					case "p":
						input[int(lusion.value)].power = false;
					break;
					case "o":
						input[int(lusion.value)].object = false;
					break;
					case "c":
						input[int(lusion.value)].criminal = false;
					break;
					case "v":
						input[int(lusion.value)].victim = false;
					break;
					case "k":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								s1 = input[m].kinsmen.indexOf(input[n].name);
								s2 = input[n].kinsmen.indexOf(input[m].name);
								if ( s1 != -1)
									input[m].kinsmen.splice(s1,1);
								if ( s2 != -1)
									input[n].kinsmen.splice(s2,1);
							}							
						}
					break;
					case "s":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								s2 = input[n].kinsmen.indexOf(input[m].name);
								if ( input[n].spouse == input[m].name)
									input[n].spouse = "";
								if ( input[m].spouse == input[n].name)
									input[m].spouse = "";
							}							
						}
					break;
					case "l":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								s1 = input[m].lovers.indexOf(input[n].name);
								s2 = input[n].lovers.indexOf(input[m].name);
								if ( s1 != -1)
									input[m].lovers.splice(s1,1);
								if ( s2 != -1)
									input[n].lovers.splice(s2,1);
							}							
						}
					break;
					case "h":
						for ( j = 0; j < lusion.value.length; j++)
						{
							for (k = j + 1 ; k < lusion.value.length; k++)
							{
								m = int(lusion.value.charAt(j));
								n = int(lusion.value.charAt(k));
								s1 = input[m].hates.indexOf(input[n].name);
								s2 = input[n].hates.indexOf(input[m].name);
								if ( s1 != -1)
									input[m].hates.splice(s1,1);
								if ( s2 != -1)
									input[n].hates.splice(s2,1);
							}							
						}
					break;
				}
			}
			
			var str:String;
			str = new String(Description);
			for (i = 0; i < input.length; i++)
			{
				p = input[i];
				str=str.replace((i+1).toString(), p.name);
			}
			FlxG.gstring += str + "  ";
			
			return input;
		}
		
		public static function IntToLetter(n:int):String
		{
			switch (n)
			{
				case 0:
					return "A";
				case 1:
					return "B";
				case 2:
					return "C";
			}
			trace ("IntToLetter Fail:" + n.toString());
			return "";
		}

		public function RequirementsString():String
		{
			var s:String;
			s = new String();
			s += "Before:\n";
			
			var i:int;
			var j:int;
			var lusion:Lusion;
			
			for (i = 0; i < PreIncludes.length; i++)
			{
				lusion = PreIncludes[i];								
				s += " ";
				
				if (lusion.KeyNameBefore())
					 s += lusion.KeyName()+" ";
					 
				for (j = 0; j < lusion.value.length; j++)
				{
					s += IntToLetter(int(lusion.value.charAt(j))) + " ";
				}
				
				if (!lusion.KeyNameBefore())
					 s += lusion.KeyName();
					 
				s += "\n";				
			}
			
			for (i = 0; i < PreExcludes.length; i++)
			{
				lusion = PreExcludes[i];								
				if (lusion.key == "v")//don't show "you don't need to be dead" status :P
					continue;
				s += " ";
				

				if (lusion.KeyNameBefore())
					 s += lusion.NotKeyName()+" ";
					 
				for (j = 0; j < lusion.value.length; j++)
				{
					s += IntToLetter(int(lusion.value.charAt(j))) + " ";
				}
				
				if (!lusion.KeyNameBefore())
					 s += lusion.NotKeyName();
					 
				s += "\n";				
			}
			
			return s;
		}
		
		public function ChangesString():String
		{
			var s:String;
			s = new String();
			s += "Effect:\n";
			
			var i:int;
			var j:int;
			var lusion:Lusion;
			
			for (i = 0; i < PostIncludes.length; i++)
			{
				lusion = PostIncludes[i];								
				s += " ";
				
				if (lusion.KeyNameBefore())
					 s += lusion.KeyName()+" ";
					 
				for (j = 0; j < lusion.value.length; j++)
				{
					s += IntToLetter(int(lusion.value.charAt(j))) + " ";
				}
				
				if (!lusion.KeyNameBefore())
					 s += lusion.KeyName();
					 
				s += "\n";				
			}
			
			for (i = 0; i < PostExcludes.length; i++)
			{
				lusion = PostExcludes[i];								
				s += " ";
				
				if (lusion.KeyNameBefore())
					 s += lusion.NotKeyName()+" ";
					 
				for (j = 0; j < lusion.value.length; j++)
				{
					s += IntToLetter(int(lusion.value.charAt(j))) + " ";
				}
				
				if (!lusion.KeyNameBefore())
					 s += lusion.NotKeyName();
					 
				s += "\n";				
			}
			
			return s;
		}
		
		public static function trim(str:String):String
		{
			const LTrimExp:RegExp = /^(\s|\n|\r|\t|\v)*/m;
			const RTrimExp:RegExp = /(\s|\n|\r|\t|\v)*$/;
		
			str = str.replace(LTrimExp, "");
			str = str.replace(RTrimExp, "");
			return str;
		}	
		
		private static function xyzTo123(str:String):int
		{
			switch(str.toLowerCase())
			{
				case "x":
					return 0;
				case "y":
					return 1;
				case "z":
					return 2;
			}
			trace("xyzERROR");
			return -1;
		}		
	}
}